(defun C:einfarb (/        SS1      SS1Len   i        NumChg   EName
                  Elist    EType    ZNACZNIK MD_ERR   M:FEHLER m:farbe
                  )
  (setq MD_ERR  *ERROR*
        *ERROR* M:FEHLER
        ) ;_ end of setq
  ;;Marke fr Zurck nach Abbruch setzen
  (command "_.UNDO" "_MARK")
  (setvar "cmdecho" 0)
  (setvar "tilemode" 1)
  (command "_.-Layer" "_unlock" "*" "")
  (prompt
    "\nElemente whlen zum ndern, oder Return fr alle... "
    ) ;_ end of prompt
  (setq SS1 (ssget))
  (if
    (null SS1)
     (setq
       SS1 (ssget "X" '((-4 . "<NOT") (0 . "VIEWPORT") (-4 . "NOT>")))
       ) ;_ end of setq
     ) ;_ end of if
  (if ss1
    (progn
      (prompt
        "\nObjekt fr Farbe picken, oder Return fr Farbwahl:"
        ) ;_ end of prompt
      (setq M:Lay (entsel))
      (if (null M:LAY)
        (progn
          (setq m:farbe (acad_colordlg 256))
          (if (null m:farbe)
            (prompt
              "\nDu musst schon 'ne Farbe whlen sonst wird das nix."
              ) ;_ end of prompt
            ) ;_ end of if
          ) ;_ end of progn
        (progn
          (if
            (null (assoc 62 (entget (car M:LAY))))
             (setq m:farbe
                    (cdr
                      (assoc
                        62
                        (tblsearch "LAYER"
                                   (cdr (assoc 8 (entget (car M:LAY))))
                                   ) ;_ end of tblsearch
                        ) ;_ end of assoc
                      ) ;_ end of cdr
                   ) ;_ end of setq
             (setq m:farbe (cdr (assoc 62 (entget (car M:LAY)))))
             ) ;_ end of if
          ) ;_ end of progn
        ) ;_ end of if
      (M:ARBEITE m:farbe)
      ) ;_ end of progn
    ) ;_ end of if
  ) ;_ end of defun
(defun M:ARBEITE (m:farbe /)
  (setq SS1Len (sslength SS1)
        i      0
        NumChg 0
        ) ;_ end of setq
  (prompt "\n  Arbeite.")
  (terpri)
  (while (< i SS1Len)
    (cond
      (ZNACZNIK
       (setq ZNACZNIK NIL)
       (princ (strcat (itoa NumChg) "\r \\ "))
       )
      (t
       (setq ZNACZNIK
              (princ (strcat (itoa NumChg) "\r / "))
             ) ;_ end of setq
       )
      ) ;_ end of cond
    (setq EName (ssname SS1 i)
          EList (entget EName)
          EType (cdr (assoc 0 EList))
          ) ;_ end of setq
    (cond
      ((= EType "INSERT")
       (setq
         EList (zeroz 62 EList M:farbe)
         ) ;_ end of setq
       (if (null (tblsearch "BLOCK" (cdr (assoc 2 EList))))
         (progn
           (setq EARX_BTAA (tblnext "BLOCK" T))
           (while
             (/= EARX_BTAA nil)
              (if
                (wcmatch (cdr (assoc 2 EARX_BTAA)) (cdr (assoc 2 EList)))
                 (progn
                   (setq EARX_BTAB EARX_BTAA)
                   (setq EARX_BTAA nil)
                   ) ;_ end of progn
                 (setq EARX_BTAA (tblnext "BLOCK"))
                 ) ;_ end of if
              ) ;_ end of while
           ) ;_ end of progn
         (setq EARX_BTAB (tblsearch "BLOCK" (cdr (assoc 2 EList))))
         ) ;_ end of if
       (setq EARX_BLK (cdr (assoc -2 EARX_BTAB)))
       (while EARX_BLK
         (cond
           (ZNACZNIK (setq ZNACZNIK NIL) (princ "\r \\ "))
           (t (setq ZNACZNIK (princ "\r / ")))
           ) ;_ end of cond
         (setq ELIST (entget EARX_BLK)
               EType (cdr (assoc 0 EList))
               ) ;_ end of setq
         (setq EList (zeroz 62 EList M:farbe))
         (if ELIST
           (entmod ELIST)
           ) ;_ end of if
         (entupd ENAME)
         (setq EARX_BLK (entnext EARX_BLK))
         ) ;_ end of while
       (if (= (cdr (assoc 66 (setq EList (entget ENAME)))) 1)
         (while (/= (cdr (assoc 0 EList)) "SEQEND")
           (setq
             EList (zeroz 62 EList M:farbe)
             EList (entget (entnext (cdr (assoc -1 EList))))
             ) ;_ end of setq
           (entupd ENAME)
           ) ;_ end of while
         ) ;_ end of if
       )
      (T
       (setq EList (zeroz 62 EList M:farbe))
       )
      ) ;_ end of cond
    (setq i (1+ i))
    ) ;_ end of while
  (vla-regen
    (vla-get-activedocument
      (vlax-get-acad-object)
      ) ;_ end of vla-get-activedocument
    acAllViewports
    ) ;_ end of vla-regen
  (princ)
  ) ;_ end of defun

(prompt
  "\nProgramm zum Verndern aller ausgewhlten Objekte auf eine auszuwhlende Farbe.\nAufruf des Programms mit: \"einfarb\" !"
  ) ;_ end of prompt
(princ) ;_ Fngt das nil vom prompt ab

(defun M:FEHLER (MSG)
  (command "_.UNDO" "_BACK")
  (setq *ERROR* MD_ERR)
  (princ
    (strcat "Fehler! AutoCAD meldet: \"" MSG "\" als Ursache.")
    ) ;_ end of princ
  (princ)
  ) ;_ end of defun

(defun zeroz (key ZEList col / OPList NPList)
  (if (= (cdr (assoc 0 ZEList)) "ATTRIB")
    (setq test nil)
    ) ;_ end of if
  (setq OPList (assoc key ZEList))
  (if (/= OPList nil)
    (setq NPList (cons key col)
          ZEList (subst NPList OPList ZEList)
          ) ;_ end of setq
    (setq ZEList
           (append (reverse (member (assoc 8 ZEList) (reverse zelist)))
                   (cons (cons key col)
                         (cdr (member (assoc 8 ZEList) zelist))
                         ) ;_ end of cons
                   ) ;_ end of append
          ) ;_ end of setq
    ) ;_ end of if
  (entmod ZEList)
  ZELIST
  ) ;_ end of defun

 ;|Visual LISP Format Options
(72 2 40 1 T "end of " 60 9 0 0 0 nil T nil T)
;*** KEINEN Text unterhalb des Kommentars hinzufgen! ***|;
